let fs = require('fs')
let _ = require('lodash')
let moment = require('moment-timezone')
run()

let adder = []
let root = ''

async function run() {

    let configs = await fs.readdirSync('last1000/')
    root = configs[0]
    configs = await fs.readdirSync('last1000/' + root + '/')
    let arr = []

    let arrSide = []

    let total = []
    let levelPlus = []
    let types = []

    for (let i = 0; i < configs.length; i++) {


        let config = await fs.readFileSync('./last1000/' + root + '/' + configs[i] + '/default/compound1000.json', 'utf8')
        config = JSON.parse(config)


        for (let j = 0; j < config.length; j++) {
            total.push(config[j].total)
            let dateString = config[j].dateString.split('_')
            let runUpString = config[j].runupString.split('_')
            let platfrom = config[j].platform.split('-')[1]

            let arrDate = []
            for (let z = 0; z < dateString.length - 2; z++)
                arrDate.push(dateString[z])
            let sideString = config[j].sideString.split('_')
            let countOfshort = 0
            let countOfLong = 0
            for (let z = 0; z < sideString.length - 2; z++)
                if (sideString[z] === 'LONG')
                    countOfLong++
                else
                    countOfshort++
            let arrRunup = []
            for (let z = 0; z < runUpString.length - 2; z++)
                arrRunup.push(parseFloat(runUpString[z]))

            // console.log(arrRunup)
            arrRunup = _.orderBy(arrRunup)


            add(config[j].total, arrDate, config[j].type.split('targetPercentage:false')[1])

            addShortLong(config[j].total, countOfshort, countOfLong)
            addPoftrade(config[j].total, config[j].pftrade)
            addRunup(config[j].total, arrRunup[0], arrRunup[arrRunup.length - 1])
            addPlatform(config[j].total, platfrom)
        }


    }

    console.log('hi')

    adder = _.orderBy(adder, ['total'], ['asc']);


    for (let i = 0; i < adder.length; i++) {
        for (let z = i + 1; z < adder.length; z++) {
            add(adder[i].total, adder[z].dates)
        }
    }

    for (let i = 0; i < adder.length; i++) {
        for (let z = i + 1; z < adder.length; z++) {
            addRunup(adder[i].total, adder[z].minRunup, adder[z].maxRunup)
        }
    }

    for (let i = 0; i < adder.length; i++) {
        let countOfShort = adder[i].short
        let countOfLong = adder[i].long
        for (let z = i + 1; z < adder.length; z++) {
            countOfShort = countOfShort + adder[z].short
            countOfLong = countOfLong + adder[z].long
        }
        addShortLong(adder[i].total, countOfShort, countOfLong)
    }


    for (let i = 0; i < adder.length; i++) {
        for (let z = i + 1; z < adder.length; z++) {
            let types = adder[z].type
            for (let l = 0; l < types.length; l++)

                add(adder[i].total, null, types[l])
        }
    }

    for (let i = 0; i < adder.length; i++) {
        for (let z = i + 1; z < adder.length; z++) {
            let pfTrade = adder[z].pfTrade
            for (let l = 0; l < pfTrade.length; l++)

                addPoftrade(adder[i].total, pfTrade[l])
        }
    }

    for (let i = 0; i < adder.length; i++) {
        for (let z = i + 1; z < adder.length; z++) {
            let platfrom = adder[z].platfrom
            for (let l = 0; l < platfrom.length; l++)

                addPlatform(adder[i].total, platfrom[l])
        }
    }


    for (let i = 0; i < adder.length; i++) {
        adder[i].dates = _.uniq(adder[i].dates)
        adder[i].dates = _.orderBy(adder[i].dates)
        adder[i].countDay = adder[i].dates.length
    }
    for (let i = 0; i < adder.length; i++) {
        adder[i].type = _.uniq(adder[i].type)
        adder[i].type = _.orderBy(adder[i].type)
        adder[i].countOfType = adder[i].type.length
        adder[i].AllPlatfrom = adder[i].platfrom
        adder[i].AllPlatfrom = _.uniq(adder[i].AllPlatfrom)
        for (let n = 0; n < adder[i].platfrom.length; n++)

            adder[i].platfrom[n] = adder[i].platfrom[n].replace('R', '')
        adder[i].platfrom = _.uniq(adder[i].platfrom)

        adder[i].countOfPlatform = adder[i].platfrom.length
        //  delete  adder[i].platfrom

        adder[i].pfTrade = _.orderBy(adder[i].pfTrade)
        let temp = []
        temp.push(adder[i].pfTrade[0])
        temp.push(adder[i].pfTrade[adder[i].pfTrade.length - 1])
        adder[i].pfTrade = temp

        //   adder[i].runUp = _.orderBy(adder[i].runUp)
    }


    for (let i = 0; i < adder.length; i++) {
        let dates = adder[i].dates
        let maxDiff = 0


        for (let z = 0; z < dates.length - 1; z++) {
            let diff = getDaysDiff(dates[z], dates[z + 1])
            if (diff > maxDiff)
                maxDiff = diff
        }

        adder[i].diffDay = maxDiff
    }

    for (let i = 0; i < adder.length; i++) {
        let dates = adder[i].dates
        let maxDiff = 0


        for (let z = 0; z < dates.length - 1; z++) {
            let diff = getDaysDiff(dates[z], dates[z + 1])
            if (diff > maxDiff)
                maxDiff = diff
        }

        adder[i].diffDay = maxDiff
    }
    createPlatfileADV(JSON.stringify(adder, null, 2))
    for (let i = 0; i < adder.length; i++) {
       // adder[i].platfrom = adder[i].platfrom.replace('R', '')
        delete adder[i].platfrom


    }

    console.log(adder)


    createConfileADV(JSON.stringify(adder, null, 2))


}


function add(total, dates, type) {
    let found = false
    for (let i = 0; i < adder.length; i++)
        if (adder[i].total === total) {
            found = true
            if (dates !== null) {
                for (let z = 0; z < dates.length; z++)
                    adder[i].dates.push(dates[z])


            }

            if (typeof type !== "undefined")
                adder[i].type.push(type)
        }

    if (found)
        return

    adder.push({
        total: total,
        dates: dates,
        countDay: dates.length,
        type: [type],
        pfTrade: [],
        short: 0,
        long: 0,
        minRunup: 100,
        maxRunup: 0,
        platfrom: []
    })

}


function addShortLong(total, short, long) {
    for (let i = 0; i < adder.length; i++)
        if (adder[i].total === total) {

            adder[i].short = adder[i].short + short
            adder[i].long = adder[i].long + long
        }
}

function addPoftrade(total, pfTrade) {
    for (let i = 0; i < adder.length; i++)
        if (adder[i].total === total) {

            adder[i].pfTrade.push(pfTrade)

        }
}

function addPlatform(total, platform) {
    for (let i = 0; i < adder.length; i++)
        if (adder[i].total === total) {

            adder[i].platfrom.push(platform)

        }
}

function addRunup(total, minRunup, maxRunup) {

    for (let i = 0; i < adder.length; i++)
        if (adder[i].total === total) {
            if (adder[i].minRunup > minRunup)
                adder[i].minRunup = minRunup

            if (maxRunup > adder[i].maxRunup)
                adder[i].maxRunup = maxRunup

        }


}

function getDaysDiff(start, closed) {
    //2019-05-25T05:34:27+04:30
    var now = moment(moment(closed, 'YYYY-MM-DD').format());
    var end = moment.duration(now.diff(moment(start, 'YYYY-MM-DD')));
    // console.log(parseInt(end.asDays()))
    return parseInt(end.asDays())


}

function createfileADV(data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile('date.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function getDaysDiff(start, closed) {
    //2019-05-25T05:34:27+04:30
    var now = moment(moment(closed, 'YYYY-MM-DD').format());
    var end = moment.duration(now.diff(moment(start, 'YYYY-MM-DD')));
    // console.log(parseInt(end.asDays()))
    return parseInt(end.asDays())


}

function createConfileADV(data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile('con3.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}

function createPlatfileADV(data) {
    // console.log(data)
    return new Promise(function (resolve, reject) {
        fs.writeFile('plat.json', data, 'utf8', function (err) {
            if (err) reject(err);
            else resolve(data);
        });
    });
}